/*
*   connect_gui.h     (part of the eDonkey2000 linux GUI)
*
*   Define functions to
*    - show/destroy 'GUI connect' dialogue
*    - cleanup GUI variables after disconnect
*    - init GUI variables after connect
*
*   (c) 2001 Tim-Philipp Mueller <t.i.m@orange.net>
*
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ED2K_GUI_CONNECT_GUI_C_INCLUDED_
#define _ED2K_GUI_CONNECT_GUI_C_INCLUDED_

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <global.h>


extern gchar DUMMY_NICKNAME[];

extern GtkWidget *connect_dialog,  *ew_connect_user, *ew_connect_pass, *cb_connect_makedef;
extern GtkWidget *ew_connect_host, *ew_connect_port, *ew_connect_path;

//extern int connect_timer_handle;    		// to show periodically if donkey is running or not */



void	clean_up_stuff (void);			// only close sockets and clear lists
void	cleanup_after_disconnect(void);
//gint	gui_connect_dialog_connect_button_clicked (GtkWidget *widget, gpointer data);
void	gui_connect_dialog (void);

#endif
