/*
 *   misc.h
 *
 *
 *   (c) 2001 Tim-Philipp Muller <t.i.m@orange.net>
 *
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ED2K_GUI_MISC_H_INCLUDED_
#define _ED2K_GUI_MISC_H_INCLUDED_

#include <sys/types.h>	// for pid_t
#include <gtk/gtk.h>
#define GNET_EXPERIMENTAL
#include <gnet/gnet.h>

#define misc_gnet_http_url_okay(gurl)	(!((!gurl)||(!gurl->protocol)||(g_strncasecmp(gurl->protocol,"http",4)!=0)||(!gurl->hostname)||(!gurl->resource)))


// some macros for a menu widget called 'menu'
#define MENU_ITEM_ADD(text,func,button_num,icon)	add_menuitem(menu,text,func,GUINT_TO_POINTER(button_num),icon)
#define MENU_ITEM_ADD__________				add_menuitem(menu,NULL,NULL,NULL,NULL)

#define MISC_RETURN_NUM_COMPARE(n1,n2)			if(n1>=n2){return(gint)(n1>n2);}else{return(-1);}
#define MISC_RETURN_STR_COMPARE(text1,text2)	if(1==1){if(!text2){return(text1!=NULL);}if(!text1){return(-1);}return g_strcasecmp(text1,text2);}

gint			compare_file_size_str (char *text1, char *text2);


const gchar		*hash_to_hash_str (const gchar *hash);
const gchar		*hash_str_to_hash (const gchar hash_str[]);
const gchar		*human_size (guint bytes);
const gchar		*int2str (gint i);
const gchar		*misc_get_basename_from_pid (pid_t pid, const gchar **arg1);
guint			 donkey_process_running_check (void);
gchar			*find_donkey_binary (void);

void			 invoke_browser_with_url (const gchar *url);
gchar			*get_timestamp (void);

void			 write_to_logfile (const gchar *format, ...);

const gchar		*seconds_into_human_time (guint seconds);


GtkWidget		*add_menuitem (	GtkWidget *menu,
								const gchar *text,
								void *function,
								gpointer data,
								gchar **icon);

/*void	remember_adjustment (GtkScrolledWindow *sw);
void	reinstate_adjustment (GtkScrolledWindow *sw);
*/

void			 print_download_stats_line (void);
void			 print_upload_stats_line (void);

void			 exec_command_on_complete_download (const gchar *filename);

void			 remove_junk_chunk (gchar *str, gchar *from, gchar *to);
void			 remove_junk_from_filename (gchar *str);

void			 get_text_from_gtk_clist_rows (GtkCListRow *row1, GtkCListRow *row2, guint sort_column, gchar **txt1, gchar **txt2);

// XXX - TODO: get rid of this function:
int				 strrealloccpy (char **dest, char *src);

gchar			*choplast (gchar *str);	// chops off last character of a string, returns ptr to string

gint			 spawn_file_preview (const gchar *filename, const gchar *extension);

gchar			**misc_get_array_of_lines_from_textfile (const gchar *filename);

guint32			 misc_gnet_inetaddr_get_ip (const GInetAddr *ia);

const gchar		*misc_get_extension_from_filename (const gchar *name);
const gchar		*misc_get_filetype_from_extension (const gchar *ext);

void			 misc_gtk_entry_insert_text_handler (GtkEntry *entry, const gchar *text, gint length, gint *position, gpointer pxData_E);

gint			 misc_get_ncpus (void);

gboolean		 misc_ip_is_local (guint32 ip);

gboolean		 misc_check_if_ed2klink_is_valid (const gchar *ed2klink, gchar **fn, guint *fnsize, gchar **hashstring);

GSList			*misc_get_sorted_records_list_from_clist_selection (GList *selection, GtkCList *clist, GCompareFunc func);

#endif
