/***************************************************************************
                          misc_strings.c  -  description
                             -------------------
    begin                : Fri Nov 29 2002
    copyright            : (C) 2002 by Tim-Philipp Mller
    email                : t.i.m@orange.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "misc_strings.h"


/* misc_strings_unescape_url
 *
 * Some browsers pass ed2k-links to the clipboard and escape
 *  the '|' char and others by '%xx'. This routine unescapes
 *  the given string.
 *
 */

void
misc_strings_unescape_url (gchar *s)
{
	gchar	*pos, *found;

	g_return_if_fail (s != NULL);

	pos = s;
	while ((found=strchr(pos,'%')))
	{
		guint hexval;

		if (*(found+1) == '%')
		{
			pos = found+2;
			continue;
		}

		if (sscanf(found+1,N_("%2x"), &hexval) == 1)
		{
			*found = (gchar)hexval;
			g_memmove(found+1, found+3, strlen(found+3)+1);
		}

		pos++;
	}
}

